﻿
#script de "compilation" d'un composant joomla.
#code source librement adaptable.
#copyright 2014 Jean-Claude Allinger.
#adresse jcallinger@laboiteinformatique.ch
#Note: il s'agit bien evidemment pas d'une compilation réelle. 
#Note: Les fichiers sont copiés de l'emplacement de développement
#note: dans un emplacement où il sera mis en forme (\admin et \site) puis zippé, prêt à être installer.
#note: le fichier d'installation avec l'extention xml est copié à la racine du zip. 
#note: la valeur de version est extraite du fichier d'installation du composant.
#note: Je part du principe que le développement se fait avec un amp et que la structure des fichier est identique à joomla
#note: administrator/components/com_lecomposant
#note: components/com_lecomposant
#note: 


clear

# import param.ini
$file = "params.ini"

function Get-IniContent ($filePath)
{
	$ini = @{}
	switch -regex -file $FilePath
	{
		"^\[(.+)\]" # Section
		{
			$section = $matches[1]
			$ini[$section] = @{}
			$CommentCount = 0
		}
		"^(;.*)$" # Comment
		{
			$value = $matches[1]
			$CommentCount = $CommentCount + 1
			$name = "Comment" + $CommentCount
			$ini[$section][$name] = $value
		}
		"(.+?)\s*=(.*)" # Key
		{
			$name,$value = $matches[1..2]
			$ini[$section][$name] = $value
		}
	}
	return $ini
}

$getini = Get-IniContent $file

#variables à modifier dans param.ini selon l'environnement.
$component_name = $getini.param.component_name
$site_dev_name = $getini.param.site_dev_name
$type = $getini.param.type
$com_prod_path = $getini.param.com_prod_path
$com_dev_path = $getini.param.com_dev_path

echo $component_name
echo $site_dev_name
echo $type
echo $com_prod_path
echo $com_dev_path


#construction du chemin de developpement. 
$admin_dev_path = $com_dev_path + $site_dev_name + "\administrator\components\" + $type + $component_name

echo $admin_dev_path "....."

$site_dev_path = $com_dev_path + $site_dev_name + "\components\" + $type + $component_name

echo $site_dev_path "......"

#construction du chemin du fichier d'installation xml
$install_xml_file_dev = $admin_dev_path + "\"+ $component_name + ".xml"

echo $install_xml_file_dev"....."

#recherche de la version du composant.
$xml = New-Object System.Xml.XmlDocument -Property @{'Load'=$install_xml_file_dev}
$ver = $xml.extension.version[1]


#construction du nom de compliation

$date = (get-date).ToString("dd_MM_yyy_HH_mm_ss")



$compil_name = $type + $component_name + "_Ver" + $ver.Replace('.', '_') + "_dte" + $date


$com_prod_files = $com_prod_path + $compil_name + "\"
$site_prod = $com_prod_files + "site\"
$admin_prod = $com_prod_files + "admin\"

#clear

echo $site_dev_path + $site_prod

Copy-Item $site_dev_path -Destination $site_prod -Recurse

echo $admin_dev_path + $admin_prod

Copy-Item $admin_dev_path -Destination $admin_prod -Recurse

echo $install_xml_file_dev + $com_prod_files

Copy-Item $install_xml_file_dev -Destination $com_prod_files 


$zipname = $com_prod_path + $compil_name + ".zip"

echo $zipname

#création du fichier zip.

function New-ZipFile
{
    [CmdletBinding()]
    param(
            [Parameter(Mandatory=$true)]
            [string]
            [ValidateNotNullOrEmpty()]
            $Name,
 
            [Parameter(Mandatory=$true)]
            [string]
            [ValidateNotNullOrEmpty()]
            $Source
    )
    [Reflection.Assembly]::LoadWithPartialName( "System.IO.Compression.FileSystem" )
    $compressionLevel = [System.IO.Compression.CompressionLevel]::Optimal
    [System.IO.Compression.ZipFile]::CreateFromDirectory( $Source, $Name, $compressionLevel, $false )
 
    Get-Item $Name
}


New-ZipFile -Name $zipname -Source $com_prod_files


Invoke-Item $com_prod_path


